/**
 * Simulation of process scheduling algorithms
 *
 * Ron Mak
 * Department of Computer Engineering
 * San Jose State University
 */
#include "HPF.h"

void HPF::age_processes(int quantum)
{
    for (int i = 1; i < PRIORITY_QUEUE_COUNT; i++)
    {
        vector<Process *> *pq = &priority_queues[i];
        int j = 0;

        while (j < pq->size())
        {
            Process *p = (*pq)[j];

            if (--p->age > 0) j++;
            else
            {
                // Bump up the process priority and move it
                // to the end of the higher priority queue.
                p->priority--;
                p->age = MAX_AGE;
                priority_queues[i-1].push_back(p);
                pq->erase(pq->begin() + j);

                printf("At %3d: %c now priority %d\n",
                       quantum, p->name, p->priority);
            }
        }
    }
}
