/**
 * Simulation of process scheduling algorithms
 *
 * Ron Mak
 * Department of Computer Engineering
 * San Jose State University
 */
#ifndef HPF_NP_H_
#define HPF_NP_H_

#include "HPF.h"

/**
 * Non-Preemptive High Priority First (HPS-NP) algorithm.
 */
class HPF_NP: public HPF
{
public:
    HPF_NP(int rcount, int pcount, int qlimit)
        : HPF(rcount, pcount, qlimit) {}

    virtual ~HPF_NP() {}

private:
    void prepare_run(int run_index);
    void run_algorithm();
};

#endif /* HPF_NP_H_ */
