/**
 * Simulation of process scheduling algorithms
 *
 * Ron Mak
 * Department of Computer Engineering
 * San Jose State University
 */
#ifndef HPF_P_H_
#define HPF_P_H_

#include "HPF.h"

/**
 * Preemptive High Priority First (HPS-P) algorithm.
 */
class HPF_P: public HPF
{
public:
    HPF_P(int rcount, int pcount, int qlimit)
        : HPF(rcount, pcount, qlimit) {}

    virtual ~HPF_P() {}

private:
    void prepare_run(int run_index);
    void run_algorithm();
};

#endif /* HPF_P_H_ */
