/**
 * Simulation of process scheduling algorithms
 *
 * Ron Mak
 * Department of Computer Engineering
 * San Jose State University
 */
#ifndef RUNSTATS_H_
#define RUNSTATS_H_

/**
 * Averages over the processes of each simulation run.
 */
class RunStats
{
public:
    RunStats() : average_wait_time(0.0), average_turnaround(0.0),
                 average_throughput(0.0) {}
    virtual ~RunStats() {}

    double average_wait_time;
    double average_turnaround;
    double average_throughput;
};

#endif /* RUNSTATS_H_ */
